from Screen import Screen
from Components.Pixmap import Pixmap, MovingPixmap
from Components.Label import Label
from Components.ActionMap import ActionMap
from Components.HelpMenuList import HelpMenuList
from Components.PluginComponent import plugins 
from Components.PluginList import * 
from Plugins.Plugin import PluginDescriptor

class HelpMenu(Screen):
	def __init__(self, session, list):
		Screen.__init__(self, session)
		self.onSelChanged = [ ]
		self["list"] = HelpMenuList(list, self.close)
		self["list"].onSelChanged.append(self.SelectionChanged)
		self["rc"] = Pixmap()
		self["arrowup"] = MovingPixmap()
		self["arrowup"].hide()
		self["sh_arrowup"] = Pixmap()
		self["sh_arrowup"].hide()
		self["long_key"] = Label("")

		self["actions"] = ActionMap(["WizardActions"], 
		{
			"ok": self["list"].ok,
			"back": self.close,
		}, -1)

		self.onLayoutFinish.append(self.SelectionChanged)

	def SelectionChanged(self):
		selection = self["list"].getCurrent()
		selection = selection and selection[3]
		arrow = self["arrowup"]
		sh_arrow = self["sh_arrowup"]

		if selection and selection[0][:3] == "sh_":
			sh_arrow.show()
		else:
			sh_arrow.hide()

		if selection and selection[0][:2] == "l_":
			self["long_key"].setText(_("Long Keypress"))
		else:
			self["long_key"].setText("")

		if selection is None:
			arrow.hide()
		else:
			arrow.moveTo(selection[1], selection[2], 1)
			arrow.startMoving()
			arrow.show()

class HelpableScreen:
	def __init__(self):
		self["helpActions"] = ActionMap( [ "HelpActions" ],
			{
				"displayHelp": self.Shooter,
			})

	def showHelp(self):
		self.session.openWithCallback(self.callHelpAction, HelpMenu, self.helpList)

	def callHelpAction(self, *args):
		if len(args):
			(actionmap, context, action) = args
			actionmap.action(context, action)

	def Shooter(self):
		self.aviablePlugins = []
		have_plugins = plugins.getPlugins(PluginDescriptor.WHERE_PLUGINMENU)
		for one_plugin in have_plugins:
			self.aviablePlugins.append(PluginEntryComponent(one_plugin))
		shootNow = None
		try:
			f = open("/etc/shooter.name", "r")
			sh_line = f.readline()
			f.close()
			sh_line_splitted = sh_line.split('/')
			if (len(sh_line_splitted)>0):
				saved2run = sh_line_splitted[0]
			else:
				saved2run = " "
		except:
			saved2run = " "
			shootNow = None
		for foundPlugin in self.aviablePlugins:
			ready2run = foundPlugin[0].name
			if ( saved2run == ready2run ):
				shootNow = foundPlugin[0]
		if shootNow is not None:
			shootNow(session=self.session)
		else:
			self.session.openWithCallback(self.callHelpAction, HelpMenu, self.helpList)
	




